package br.org.indt.nokiatrends.server.files;

import java.io.File;
import java.io.FileFilter;

public class BTFileFilter implements FileFilter
{
	public static final String DEFAULT_PATTERN = "BTNOKIATRENDS";
	private String pattern = DEFAULT_PATTERN;
	private String fileExtension = null;

	public BTFileFilter(String pattern, String fileExtension) 
	{
		if (pattern!=null)
			this.pattern = pattern.toUpperCase();
		this.fileExtension = fileExtension;
	}

	public String getPattern() {
		return this.pattern;		
	}

	public String getExtension() {
		return this.fileExtension;
	}

	public boolean accept(File file) {
		if (file.isFile()) {
			String fileName = file.getName().toUpperCase(); // file name obttained by File.listFiles(FileFilter)
			if (fileName.indexOf(pattern)!=-1)
			{
				if (this.fileExtension!=null && this.fileExtension.length()>0) {
					int fileExtInd = fileName.lastIndexOf('.');
					if (fileExtInd!=-1) 
					{
						String fileExt = fileName.substring(fileName.lastIndexOf('.')+1);
						if (fileExt.equalsIgnoreCase(fileExtension))
							return true;
						else
							return false;
					}
				}
				return true;
			}
		}
		return false;
	}
}