// Zoom
// by REAS <http://www.groupc.net>

// Move the cursor over the image to alter its position. Click and press
// the mouse to zoom and set the density of the matrix by typing numbers 1-5.
// This program displays a series of lines with their heights corresponding to 
// a color value read from an image. 

// Created 10 August 2002

BImage a;
boolean onetime = true;
int[][] aPixels;
float sval = 1.0;
float nmx, nmy;
int lastMouseX,secondMouseX;
int res = 5;
float fs=0;

void setup() 
{
  lastMouseX=mouseX;
  size(640, 480);
  noFill();
  stroke(255);
  aPixels = new int[width][height];
  a = loadImage("foto.jpg");
  image(a, 0, 0);
  for(int i=0; i<height; i++) {
    for(int j=0; j<width; j++) {
      aPixels[j][i] = a.pixels[i*width+j];
    }
  }
}

void loop() 
{
  background(51);

  if (abs(mouseX - nmx) > 1.0) { 
    nmx = nmx + (mouseX-nmx)/20; 
  }
  if (abs(mouseY - nmy) > 1.0) { 
    nmy += (mouseY-nmy)/20; 
  }
  
  if(mousePressed) { 
    sval += 0.01; 
  } else {
    sval -= 0.02; 
  }
  if(sval > 2.5) { sval = 2.5; }
  if(sval < 1.0) { sval = 1.0; }
  
  translate(width/2+nmx*sval-100, height/2+nmy*sval-100, -50);
  scale(sval);
  //rotateZ(PI/9-sval+1.0);
  //rotateX(PI/sval/8-0.125);  
  if(mouseY>120){
    rotateX(fs);
//    print((float)(100-mouseY)/100);
    fs+=(0.01-(float)(100-mouseY)/10000);
    rotateX(PI/sval/8-0.125); 

  }
  else if(mouseY<80){
   rotateX(fs);
    fs-=(0.01+(float)(100+mouseY)/10000);
    rotateX(PI/sval/8-0.125); 
  }
  else{
    if(fs!=0){rotateX(fs);}
    if(fs>0){
      fs-=(0.01+(float)(100+mouseY)/10000);
    }
    else if(fs<0){
       fs+=(0.01-(float)(100-mouseY)/10000);
    }
    else{
      fs=0;
    }
  }
  translate(-width/2, -height/2, 0);
  
  float rr, gg, bb, tt;
  for(int i=0; i<width; i+=res) {
    for(int j=0; j<height; j+=res) {
      rr = red(aPixels[i][j]); 
      gg = green(aPixels[i][j]);
      bb = blue(aPixels[i][j]);
      tt = rr+gg+bb;
      stroke(rr, gg, bb);
      line(i, j, tt/10-20, i, j, tt/10 );
    }
  }
  
}

void keyPressed() {
  if(key == '1') {
    res = 1;
  } else if (key == '2') {
    res = 2; 
  } else if (key == '3') {
    res = 3;
  } else if (key == '4') {
    res = 4;
  } else if (key == '5') {
    res = 5;
  }
}






